com.ibm.openpages.api.metadata

## Interface ITypeDefinition

-     public interface ITypeDefinition

  Represents OpenPages metadata pertaining to a type part of a GRC model.

  See Also:
    `IFieldDefinition`, `IAssociationDefinition`
  Category:
    MetaData

- - ### Method Summary

    All Methods Instance Methods Abstract Methods
    Modifier and Type | Method and Description
    --- | ---
    `IAssociationDefinition` | `getAssociationDefinition(Id id)` Returns the association based on the Id.
    `java.util.List<IAssociationDefinition>` | `getChildrenAssociations()` Returns all children associations for this type (i.e., all other type definitions for which this type has a direct navigation path).
    `java.lang.String` | `getDescription()` Returns the system type description part of the model.
    `IFieldDefinition` | `getField(Id id)` Returns the field definition with the specified Id.
    `IFieldDefinition` | `getField(java.lang.String systemName)` Returns the field definition with the specified system name.
    `java.util.List<IFieldDefinition>` | `getFieldsDefinition()` Returns all field definitions part of this type definition.
    `java.util.List<IFileTypeDefinition>` | `getFileTypes()` Returns all the valid combinations of file extensions and MIME types defined for this type.
    `Id` | `getId()` Returns the unique identifier for this type.
    `java.lang.String` | `getJspPath()` Returns the path for a JSP resource associated to this type definition.
    `java.lang.String` | `getLocalizedLabel()` Returns the type definition singular name in the user locale.
    `java.util.Map<java.util.Locale,java.lang.String>` | `getLocalizedLabels()` Returns the map of the type definition singular name in every locale
    `java.lang.String` | `getLocalizedPluralLabel()` Returns the type definition plural name in the user locale.
    `java.util.Map<java.util.Locale,java.lang.String>` | `getLocalizedPluralLabels()` Returns the map of the type definition plural name in every locale
    `java.lang.String` | `getName()` Returns the system name of the type definition.
    `java.util.List<IAssociationDefinition>` | `getParentAssociations()` Returns all parent associations for this type definition (i.e., all other type definitions from which a direct navigation path to this type has been specified).
    `Id` | `getRootFolderId()` Returns the unique identifier for this type root folder.
    `java.lang.String` | `getRootFolderPath()` Returns the root folder for instances of this type.
    `boolean` | `hasFileTypes()` Returns true if this type can have an associated file.

- - ### Method Detail

    - #### getName

          java.lang.String getName()

      Returns the system name of the type definition.

      Returns:
        the type system name as a string

    - #### getLocalizedLabel

          java.lang.String getLocalizedLabel()

      Returns the type definition singular name in the user locale.

      Returns:
        localized singular name if one exist; otherwise, the system name is returned

    - #### getLocalizedLabels

          java.util.Map<java.util.Locale,java.lang.String> getLocalizedLabels()

      Returns the map of the type definition singular name in every locale

      Returns:
        type definition singular name in every locale as a map whose key is locale and value is the name.

    - #### getLocalizedPluralLabel

          java.lang.String getLocalizedPluralLabel()

      Returns the type definition plural name in the user locale.

      Returns:
        localized plural name if one exist; otherwise, the system name is returned

    - #### getLocalizedPluralLabels

          java.util.Map<java.util.Locale,java.lang.String> getLocalizedPluralLabels()

      Returns the map of the type definition plural name in every locale

      Returns:
        type definition plural name in every locale as a map whose key is locale and value is the name.

    - #### getDescription

          java.lang.String getDescription()

      Returns the system type description part of the model.

      Returns:
        the system level description as a string

    - #### getJspPath

          java.lang.String getJspPath()

      Returns the path for a JSP resource associated to this type definition.

      Returns:
        the jsp path as a string

    - #### getId

          Id getId()

      Returns the unique identifier for this type.

      Returns:
        `Id` the unique identifier for the type

    - #### getRootFolderPath

          java.lang.String getRootFolderPath()

      Returns the root folder for instances of this type. Each type defined in an OpenPages model is associated with a system generated folder.

      Returns:
        the root folder path as a string

    - #### getRootFolderId

          Id getRootFolderId()

      Returns the unique identifier for this type root folder.

      Returns:
        `Id` the root folder identifier

    - #### getField

          IFieldDefinition getField(java.lang.String systemName)

      Returns the field definition with the specified system name.

      Parameters:
        `systemName` - for the unique system name
      Returns:
        IFieldDefinition the field definition

    - #### getField

          IFieldDefinition getField(Id id)

      Returns the field definition with the specified Id.

      Parameters:
        `id` - Id of the field
      Returns:
        IFieldDefinition the field definition

    - #### getFieldsDefinition

          java.util.List<IFieldDefinition> getFieldsDefinition()

      Returns all field definitions part of this type definition.

      Returns:
        List the list of field definition

    - #### getParentAssociations

          java.util.List<IAssociationDefinition> getParentAssociations()

      Returns all parent associations for this type definition (i.e., all other type definitions from which a direct navigation path to this type has been specified). Types are organized in a directed graph that can be navigated along pre-defined paths.

      Returns:
        List the list of association definitions

    - #### getChildrenAssociations

          java.util.List<IAssociationDefinition> getChildrenAssociations()

      Returns all children associations for this type (i.e., all other type definitions for which this type has a direct navigation path).

      Returns:
        List the list of association definitions

    - #### getAssociationDefinition

          IAssociationDefinition getAssociationDefinition(Id id)

      Returns the association based on the Id.

      Parameters:
        `id` - the id of the association
      Returns:
        the association definition corresponding to the Id, if found. Otherwise, null is returned.

    - #### hasFileTypes

          boolean hasFileTypes()

      Returns true if this type can have an associated file.

      Returns:
        true if this type can have an associated file, otherwise false.

    - #### getFileTypes

          java.util.List<IFileTypeDefinition> getFileTypes()

      Returns all the valid combinations of file extensions and MIME types defined for this type.

      Returns:
        List the file type definitions

Licensed Materials - Property of IBM
OpenPages with Watson (PID: 5725-D51)
© Copyright IBM Corporation 2013, 2022. All Rights Reserved.
US Government Users Restricted Rights - Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.